con
  _clkmode        = xtal1 + pll16x       
  _xinfreq        = 5_000_000
  tiles    = vga#xtiles * vga#ytiles    
  tiles32  = tiles * 32                 
  si       = 3 'b on db-expander
  clk      = 4 'c on db-expander
  exposure = 666666  'exposure  
       
var
  long a[128]
  long  sync, pixels[tiles32]    
  word  colors[tiles]
     
obj
  ad  : "cd_ltc1298"
  vga : "vga_512x384_bitmap"
  
pub main | i,p
  
  outa[3..4]~     
  dira[3..4]~~
  ad.start(0)
  vga.start(16, @colors, @pixels, @sync)
  repeat i from 0 to tiles - 1      'set display colors
    colors[i] := $f000      
  repeat
    grab                            'grab image
    longfill(@pixels,0,tiles32)     'erase screen  
    repeat i from 0 to 127          'display image
      p := a[i]                     'get next image pixel 
      p := 0 #> p <# 383            'make sure it is in screen range y value
      plot(i*4,p)                   'plot pixel on screen
                                  
pub grab | i                        'grab line scan
   
  outa[si]~~                        'trigger si then clk
  outa[clk]~~                       
  outa[si]~                         
  outa[clk]~                        
  repeat i from 0 to 128            '129 clk's
    outa[clk]~~                     
    outa[clk]~                      
  waitcnt(exposure+cnt)             'exposure time
  outa[si]~~                        'trigger si then clk
  outa[clk]~~                       
  outa[si]~
  outa[clk]~
  repeat i from 0 to 127            'grab 128 pixels into a[]
    a[i] := ad.getadc(1)            'channel 1 of ltc1298 connected to ao on line scanner
    outa[clk]~~                     'added
    outa[clk]~      
      
PRI plot(x,y) | i                                        'plot pixel
 
  if x => 0 and x < 512 and y => 0 and y < 384   
    pixels[y << 4 + x >> 5] |= |< x
                 
PRI unplot(x,y) | i
                          
  if x => 0 and x < 512 and y => 0 and y < 384   
    pixels[y << 4 + x >> 5] ^= |< x
              